Request

Response

    Lists parameters in a parameter collection.
    GET

    v1/accounts/{accountId}/groups/{groupId}/collections/{collectionId}/parameters

    Lists parameters in a parameter collection. Optionally, attempt to localize that information according to a given localization fallback list.

    Resource Information

    Method and URI
    GET
    https://developer.api.autodesk.com/parameters/v1/accounts/{accountId}/groups/{groupId}/collections/{collectionId}/parameters
    Authentication Context
    user context required
    Required OAuth Scopes
    data:read
    Data Format
    JSON

    Request

    Headers

    Authorization*
    string
    Must be Bearer <token>, where <token> is obtained via a three-legged OAuth flow.
    Accept-Language
    string
    A localization list consisting of localization codes delimited by commas. For instance, a user residing in the UK may request en-GB, en-US, or en.
    Region
    string
    The region the hub’s data is provisioned in. Currently supports US, EMEA, AUS, IND, DEU, JPN, CAN, and GBR. Default is US.
    * Required

    Request

    URI Parameters

    accountId
    string: UUID or string: b.UUID
    The Autodesk Forma hub ID.
    groupId
    string
    The group ID. Currently, only one group is supported, and group id is equal to hub id. (Supporting multiple groups is considered for future enhancement).
    collectionId
    string
    The collection ID.

    Request

    Query String Parameters

    offset
    int
    Offset from the start of the collection to the first entry in the page. Zero based.
    limit
    int
    Determines the maximum number of objects that MAY be returned. A query MAY return fewer than the value of limit due to filtering or other reasons.
    ids
    string
    The parameter IDs split by comma. With this query parameter, you can get the specified parameters in an array.

    Response

    HTTP Status Code Summary

    200
    OK
    Successful retrieval of the parameters within the designated collection.
    207
    Multi-Status
    The best-case scenario for localization cannot be returned, but otherwise the parameters were localized in some way. The “best case” is when the first choice localization code could be used on the parameters indicated.
    400
    Bad Request
    The request could not be understood by the server due to malformed syntax.
    401
    Unauthorized
    Request has not been applied because it lacks valid authentication credentials for the target resource.
    403
    Forbidden
    The server understood the request but refuses to authorize it.
    404
    Not Found
    The resource cannot be found.
    406
    Not Acceptable
    The server cannot produce a response matching the list of acceptable values defined in the request.
    410
    Gone
    Access to the target resource is no longer available.
    429
    Too Many Requests
    User has sent too many requests in a given amount of time.
    500
    Internal Server Error
    An unexpected error occurred on the server.
    503
    Service Unavailable
    Server is not ready to handle the request.

    Response

    Body Structure (200)

    Expand all
    id
    string
    The parameter ID.
    name
    string
    The parameter name.
    description
    string
    The parameter description.
    specId
    string
    The parameter spec ID. See the field guide about the definition of spec.”
    valueTypeId
    string
    The identifier of the storage value type, which could be a primitive type ID, such as Bool, Int64, Float64, String, DateTime, URI, Date, or a complex type ID.
    readOnly
    boolean
    Indicates if the parameter is to be treated as read-only or not by a UI client. Immutable once set.
    metadata
    array: object
    The parameter metadata. This is a collection of metadata objects that provide additional information about the parameter. Refer to the table, below for details on the meaning for each metadata object. Returned metadata may vary from one parameter to another. For example, to support the use of a parameter in Revit, the metadata object might record category bindings and an instance/type assignment.
    id
    string
    The metadata ID.
    value
    varies
    The metadata value. This can be of type Boolean, string, object, array of strings, array of objects, or null.
    createdBy
    string
    User that created the parameter.
    createdAt
    string
    A Time ISO 8601 Timestamp in UTC Timezone indicating when the parameter was created.
    localization
    object
    An object recording information about how this data was localized. If this property is undefined, then no localization attempt was made and the information is presented in its storage form.
    origin
    object
    Information about what instance of the resource the localization was based on.
    version
    string
    The version of the source data the localization is based on.
    locale
    object
    The localization tags of this parameter data as it was returned. If the value of selection is “LCL_MISSING” then locale is null.
    language
    string
    The ISO-439 language code.
    region
    string
    The ISO-3166-1 2 letter region code or UN M.49 three digit region code. If no region was specified in the source localization, then the value is null.
    selection
    enum
    How the localization was chosen. Any of:
    “LCL_EXACT”: The first choice exact localization requested was available. “LCL_FALLBACK”: A fallback scheme controlled by the provided localization list and requested version was used but the first choice localization was not used. “LCL_MISSING”: There was no localization available that fulfilled the localization list.

    Metadata Fields

    These fields may be present in the metadata array. Many represent Autodesk internal controls for application behavior, but are documented here for completeness.

    Expand all
    isHidden
    boolean
    Indicates if the parameter is hidden or not in a UI client.
    isArchived
    boolean
    Indicates if the parameter is archived or not.
    instanceTypeAssociation
    string
    Indicates if the parameter is associated with element instances, element types, or neither. Possible values: NONE, INSTANCE, TYPE
    labelIds
    array: string
    List of all the labels attached to this parameter.
    group
    object
    Identifies a Properties Palette group into which the parameter may be sorted.
    bindingId
    string
    The ID of the group binding. It can be looked up in the results of the GET /classifications/groups API.
    id
    string
    The group identifier.
    categories
    array: object
    Categories of Revit elements to which the parameter may be attached.
    bindingId
    string
    The category binding ID. It can be looked up in the results of the GET /classifications/categories API.
    id
    string
    The category identifier.
    specCategoryId
    string
    For a Family Type parameter, this field identifies the Revit element category which constrains its value.
    pimPropBehavior
    string
    Controls Autodesk internal operations. May have a value such as DEFAULT, DYNAMIC_WITH_CARRY_FORWARD, DYNAMIC, or TIMELESS.
    pimPropDMBehavior
    string
    Controls Autodesk internal operations. May have a value such as SHOULD_COPY.
    pimPropCategory
    string
    Controls Autodesk internal operations. May have a value such as COMPONENT, DRAWING, or MODEL.
    pimDisplayInSummary
    boolean
    Controls Autodesk internal operations.
    pimIsSearchable
    boolean
    Controls Autodesk internal operations.

    Example

    Successful retrieval of the parameters (200).

    Request

    curl -v 'https://developer.api.autodesk.com/parameters/v1/accounts/009777bb-e1e5-4577-9800-0789677e4616/groups/009777bb-e1e5-4577-9800-0789677e4616/collections/e284ed9a-df49-4d4f-80bc-cd4de91db4cb/parameters' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a'
    

    Response

    {
      "pagination": {
        "limit": 50,
        "offset": 0,
        "totalResults": 1
      },
      "results": [
        {
          "id": "parameters.009777bbe1e5457798000789677e4616:a3ec4719e06743ef8e2f62228c631b17-1.0.0",
          "name": "Hidden2",
          "readOnly": false,
          "description": null,
          "specId": "autodesk.spec.aec:length-2.0.0",
          "metadata": [
            {
              "id": "isArchived",
              "value": false
            },
            {
              "id": "isHidden",
              "value": false
            },
            {
              "id": "labelIds",
              "value": [
                "ACRD-00685-EFPT-41973"
              ]
            },
            {
              "id": "instanceTypeAssociation",
              "value": "NONE"
            },
            {
              "id": "categories",
              "value": [
                {
                  "bindingId": "ACFT-94206-BGDE-78534",
                  "typeId": "autodesk.revit.category.family:abutmentFoundations-1.0.0"
                }
              ]
            },
            {
              "id": "group",
              "value": null
            }
          ],
          "createdBy": "JFGVKSJ7FF9M",
          "createdAt": "2022-06-28T01:50:43.000Z"
        }
      ]
    }
    
    Show More

    Request

    curl -v 'https://developer.api.autodesk.com/parameters/v1/accounts/009777bb-e1e5-4577-9800-0789677e4616/groups/009777bb-e1e5-4577-9800-0789677e4616/collections/e284ed9a-df49-4d4f-80bc-cd4de91db4cb/parameters' \
      -H 'Authorization: Bearer AuIPTf4KYLTYGVnOHQ0cuolwCW2a' \
      -H 'Accept-Language: de'
    

    Response

    {
      "pagination": {
        "limit": 50,
        "offset": 0,
        "totalResults": 1
      },
      "results": [
        {
          "id": "parameters.009777bbe1e5457798000789677e4616:a3ec4719e06743ef8e2f62228c631b17-1.0.0",
          "name": "Versteckt2",
          "readOnly": false,
          "description": null,
          "specId": "autodesk.spec.aec:length-2.0.0",
          "metadata": [
            {
              "id": "isArchived",
              "value": false
            },
            {
              "id": "isHidden",
              "value": false
            },
            {
              "id": "labelIds",
              "value": [
                "ACRD-00685-EFPT-41973"
              ]
            },
            {
              "id": "instanceTypeAssociation",
              "value": "NONE"
            },
            {
              "id": "categories",
              "value": [
                {
                  "bindingId": "ACFT-94206-BGDE-78534",
                  "typeId": "autodesk.revit.category.family:abutmentFoundations-1.0.0"
                }
              ]
            },
            {
              "id": "isHidden",
              "value": false
            },
            {
              "id": "instanceTypeAssociation",
              "value": "TYPE"
            }
          ],
          "createdBy": "JFGVKSJ7FF9M",
          "createdAt": "2022-06-28T01:50:43.000Z",
          "localization": {
            "origin": {
              "version": "1.0.0"
            },
            "locale": {
              "language": "de",
              "region": null
            },
            "selection": "LCL_EXACT"
          }
        }
      ]
    }
    
    Show More